<!-- 视频列表 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <el-button type="primary" @click="handleAdd"> 添加 </el-button>
        </div>
        <ProTable
            ref="proTableRef"
            :formData="dataStore.formData"
            :columns="dataStore.columns"
            :request-api="getUserListApi"
            :init-param="dataStore.initParam"
        >
            <template #status="scope">
                <el-tag :type="scope.row.status == 1 ? 'success' : 'danger'" effect="dark">{{
                    scope.row.status == 1 ? "启用" : "禁用"
                }}</el-tag>
            </template>
            <template #operation="scope">
                <el-button size="small" type="primary" @click="handleBtnClick('编辑', scope.row)">编辑</el-button>
                <el-button
                    size="small"
                    type="danger"
                    @click="handleBtnClick('删除', scope.row)"
                    v-if="scope.row.delete_disable == 0"
                    >删除</el-button
                >
            </template>
        </ProTable>
        <el-drawer
            v-model="dataStore.visible"
            :show-close="true"
            :size="600"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="handleBeforeClone"
            destroy-on-close
        >
            <template #header="{ titleId, titleClass }">
                <h4 :id="titleId" :class="titleClass">{{ dataStore.title }}</h4>
            </template>
            <div>
                <rulesForm
                    :ruleForm="dataStore.editRuleForm"
                    :formData="dataStore.editFormData"
                    :rules="dataStore.rules"
                    ref="formRef"
                    @handleInputBlurEmits="handleInputBlurEmits"
                >
                </rulesForm>
            </div>
            <template #footer>
                <div style="flex: auto">
                    <el-button @click="handleResetClick">重置</el-button>
                    <el-button type="primary" @click="handleConfirmClick">确认</el-button>
                </div>
            </template>
        </el-drawer>
    </div>
</template>

<script setup lang="ts" name="userListIndex">
import ProTable from "@/components/ProTable/index.vue";
import rulesForm from "@/components/rulesForm/index.vue";
import CryptoJS from "crypto-js";
//接口
import {
    getUserListApi,
    getUserListDelApi,
    getUserListDetailsApi,
    getUserListEditUpApi,
    getUserListSaveApi
} from "@/api/modules/userList";
import { getRolesListApi } from "@/api/modules/roleList";

import { messageBox } from "@/utils/messageBox";
import { useMsg } from "@/hooks/useMsg";
//深拷贝方法
import { cloneDeep } from "lodash-es";
//表格和搜索條件
import { RULE_FORM, FORM_DATA, COLUMNS, EDIT_FORM_DATA, EDIT_RULE_FORM, RULES, RULES1 } from "./constant/index";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTableRef = ref<any>(null);
const formRef: any = ref(null);
// 数据源
const dataStore = reactive<any>({
    title: "添加用户",
    columns: COLUMNS, //列表配置项
    rules: cloneDeep(RULES), //抽屉表单验证
    editRuleForm: cloneDeep(EDIT_RULE_FORM),
    editFormData: cloneDeep(EDIT_FORM_DATA), //抽屉表单配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索參數
    formData: FORM_DATA, //搜索配置项
    visible: false,
    selectRow: {} //当前选择的row
});

//抽屉确认
const handleConfirmClick = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef!.validate((valid: any) => {
        if (valid) {
            dataStore.title === "添加用户" ? getUserListSave() : getUserListEditUp();
            console.log("submit!");
        } else {
            console.log("error submit!");
            return false;
        }
    });
};
//重置验证状态
const resetFields = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef.resetFields();
};
//抽屉重置
const handleResetClick = () => {
    if (dataStore.title === "添加用户") {
        resetFields();
    } else {
        getUserListDetails(dataStore.editRuleForm.id);
    }
};
//添加
const handleAdd = () => {
    dataStore.title = "添加用户";
    dataStore.visible = true;
};
//抽屉关闭前的钩子
const handleBeforeClone = () => {
    dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
    resetFields();
    dataStore.visible = false;
};

//按钮点击事件
const handleBtnClick = (type: any, row: any) => {
    //编辑
    if (type === "编辑") {
        dataStore.rules = cloneDeep(RULES1);
        dataStore.visible = true;
        dataStore.title = "编辑用户";
        getUserListDetails(row.id);
        return;
    }
    //删除
    if (type === "删除") {
        getUserListDel(row.id);
    }
};
//删除
const getUserListDel = (id: any) => {
    messageBox("你确定要删除?", async () => {
        const result = await getUserListDelApi(id);
        if (result?.code === 0) {
            const { msg } = result;
            useMsg("success", msg);
            proTableRef?.value?.getTableList();
        }
    });
};
//详情
const getUserListDetails = async (id: any) => {
    const result = await getUserListDetailsApi(id);
    if (result?.code === 0) {
        dataStore.editRuleForm = result?.data;
    }
};
const setPwMD5 = () => {
    dataStore.editRuleForm.password = CryptoJS.MD5(dataStore.editRuleForm.password)?.toString();
    dataStore.editRuleForm.repassword = CryptoJS.MD5(dataStore.editRuleForm.repassword)?.toString();
};
//保存
const getUserListSave = async () => {
    // repassword,password
    setPwMD5();
    const result = await getUserListSaveApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        const { msg } = result;
        useMsg("success", msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        proTableRef?.value?.getTableList();
    }
};
//更新
const getUserListEditUp = async () => {
    if (dataStore.editRuleForm.password && dataStore.editRuleForm.repassword) {
        setPwMD5();
    }

    const result = await getUserListEditUpApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        const { msg } = result;
        useMsg("success", msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        proTableRef?.value?.getTableList();
    }
};
//角色
const getRolesList = async () => {
    const result = await getRolesListApi();
    if (result?.code === 0) {
        let arr: any = [];
        result?.data.forEach((item: any) => {
            arr.push({
                value: item.id,
                label: item.name
            });
            dataStore.editFormData[2].options = arr;
        });
    }
};
getRolesList();
//验证密码是否一致
const handleInputBlurEmits = () => {
    if (dataStore.editRuleForm.password && dataStore.editRuleForm.repassword) {
        if (dataStore.editRuleForm.password !== dataStore.editRuleForm.repassword) {
            useMsg("warning", "请保持用户密码与确认密码一致！");
        }
    }
};
</script>

<style scoped></style>
